package ingress

import (
	interfaces "k8s.libre.sh/interfaces"
	meta "k8s.libre.sh/meta"
	parameters "k8s.libre.sh/parameters"

	networkingv1beta1 "k8s.io/api/networking/v1beta1"
)

// SecretRef represents a reference to a Secret
type SecretRef string

// +kubebuilder:object:generate=true
type Ingress struct {
	*meta.ObjectMeta               `json:"meta,omitempty"`
	*networkingv1beta1.IngressSpec `json:",inline"`
}

func (r *Ingress) GetIngressRules() []networkingv1beta1.IngressRule { return r.Rules }
func (r *Ingress) GetIngressTLS() []networkingv1beta1.IngressTLS    { return r.TLS }
func (r *Ingress) GetIngressClassName() *string                     { return r.IngressClassName }

func (o *Ingress) Mutate(obj interfaces.Object) error {
	//	o.Service.Meta = o.Meta
	MutateIngress(o, obj.(*networkingv1beta1.Ingress))
	meta.MutateMeta(o, obj)
	return nil
}

func (o *Ingress) GetObject() interfaces.Object {
	return &networkingv1beta1.Ingress{}
}

func (o *Ingress) SetSettings(parameters parameters.Parameters) {}
